<template>
  <div class="modal" :class="{ 'd-block': open }" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title text-muted">{{ title }}</h5>
          <button
            type="button"
            class="close"
            data-dismiss="modal"
            aria-label="Close"
            @click="closeForm"
          >
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <form @submit.prevent>
            <slot />
          </form>
        </div>
        <div class="modal-footer">
          <div class="d-flex justify-content-between w-100">
            <slot name="footer" />
          </div>
        </div>
      </div>
    </div>
    <teleport to="body">
      <overlay v-if="open" :open="open" />
    </teleport>
  </div>
</template>
<script lang="ts">
import { defineComponent } from "vue";
import Overlay from "../components/Overlay.vue";

export default defineComponent({
  components: { Overlay },
  emits: ["close"],
  props: {
    title: {
      type: String,
    },
    open: {
      type: Boolean,
    },
  },
  methods: {
    closeForm() {
      this.$emit("close");
    },
  },
});
</script>
